/**
 * Highstock JS v11.2.0 (2023-10-30)
 *
 * Indicator series type for Highcharts Stock
 *
 * (c) 2010-2021 Daniel Studencki
 *
 * License: www.highcharts.com/license
 */!function(t){"object"==typeof module&&module.exports?(t.default=t,module.exports=t):"function"==typeof define&&define.amd?define("highcharts/indicators/acceleration-bands",["highcharts","highcharts/modules/stock"],function(e){return t(e),t.Highcharts=e,t}):t("undefined"!=typeof Highcharts?Highcharts:void 0)}(function(t){"use strict";var e=t?t._modules:{};function i(t,e,i,a){t.hasOwnProperty(e)||(t[e]=a.apply(null,i),"function"==typeof CustomEvent&&window.dispatchEvent(new CustomEvent("HighchartsModuleLoaded",{detail:{path:e,module:t[e]}})))}i(e,"Stock/Indicators/MultipleLinesComposition.js",[e["Core/Series/SeriesRegistry.js"],e["Core/Utilities.js"]],function(t,e){var i;let{sma:{prototype:a}}=t.seriesTypes,{defined:o,error:s,merge:n}=e;return function(t){let i=[],r=["bottomLine"],p=["top","bottom"],l=["top"];function h(t){return"plot"+t.charAt(0).toUpperCase()+t.slice(1)}function c(t,e){let i=[];return(t.pointArrayMap||[]).forEach(t=>{t!==e&&i.push(h(t))}),i}function d(){let t=this,e=t.pointValKey,i=t.linesApiNames,r=t.areaLinesNames,p=t.points,l=t.options,d=t.graph,u={options:{gapSize:l.gapSize}},f=[],y=c(t,e),m=p.length,g;if(y.forEach((t,e)=>{for(f[e]=[];m--;)g=p[m],f[e].push({x:g.x,plotX:g.plotX,plotY:g[t],isNull:!o(g[t])});m=p.length}),t.userOptions.fillColor&&r.length){let e=y.indexOf(h(r[0])),i=f[e],o=1===r.length?p:f[y.indexOf(h(r[1]))],s=t.color;t.points=o,t.nextPoints=i,t.color=t.userOptions.fillColor,t.options=n(p,u),t.graph=t.area,t.fillGraph=!0,a.drawGraph.call(t),t.area=t.graph,delete t.nextPoints,delete t.fillGraph,t.color=s}i.forEach((e,i)=>{f[i]?(t.points=f[i],l[e]?t.options=n(l[e].styles,u):s('Error: "There is no '+e+' in DOCS options declared. Check if linesApiNames are consistent with your DOCS line names."'),t.graph=t["graph"+e],a.drawGraph.call(t),t["graph"+e]=t.graph):s('Error: "'+e+" doesn't have equivalent in pointArrayMap. To many elements in linesApiNames relative to pointArrayMap.\"")}),t.points=p,t.options=l,t.graph=d,a.drawGraph.call(t)}function u(t){let e,i=[],o=[];if(t=t||this.points,this.fillGraph&&this.nextPoints){if((e=a.getGraphPath.call(this,this.nextPoints))&&e.length){e[0][0]="L",i=a.getGraphPath.call(this,t),o=e.slice(0,i.length);for(let t=o.length-1;t>=0;t--)i.push(o[t])}}else i=a.getGraphPath.apply(this,arguments);return i}function f(t){let e=[];return(this.pointArrayMap||[]).forEach(i=>{e.push(t[i])}),e}function y(){let t=this.pointArrayMap,e=[],i;e=c(this),a.translate.apply(this,arguments),this.points.forEach(a=>{t.forEach((t,o)=>{i=a[t],this.dataModify&&(i=this.dataModify.modifyValue(i)),null!==i&&(a[e[o]]=this.yAxis.toPixels(i,!0))})})}t.compose=function(t){if(e.pushUnique(i,t)){let e=t.prototype;e.linesApiNames=e.linesApiNames||r.slice(),e.pointArrayMap=e.pointArrayMap||p.slice(),e.pointValKey=e.pointValKey||"top",e.areaLinesNames=e.areaLinesNames||l.slice(),e.drawGraph=d,e.getGraphPath=u,e.toYData=f,e.translate=y}return t}}(i||(i={})),i}),i(e,"Stock/Indicators/ABands/ABandsIndicator.js",[e["Stock/Indicators/MultipleLinesComposition.js"],e["Core/Series/SeriesRegistry.js"],e["Core/Utilities.js"]],function(t,e,i){let{sma:a}=e.seriesTypes,{correctFloat:o,extend:s,merge:n}=i;class r extends a{constructor(){super(...arguments),this.data=void 0,this.options=void 0,this.points=void 0}getValues(t,e){let i,a,s,n,r,p,l,h,c,d,u;let f=e.period,y=e.factor,m=e.index,g=t.xData,x=t.yData,A=x?x.length:0,D=[],v=[],C=[],L=[],M=[];if(!(A<f)){for(u=0;u<=A;u++){if(u<A){var G,S;G=x[u][2],r=o((S=x[u][1])-G)/(o(S+G)/2)*1e3*y,D.push(x[u][1]*o(1+2*r)),v.push(x[u][2]*o(1-2*r))}u>=f&&(c=g.slice(u-f,u),d=x.slice(u-f,u),l=super.getValues.call(this,{xData:c,yData:D.slice(u-f,u)},{period:f}),h=super.getValues.call(this,{xData:c,yData:v.slice(u-f,u)},{period:f}),n=(p=super.getValues.call(this,{xData:c,yData:d},{period:f,index:m})).xData[0],a=l.yData[0],s=h.yData[0],i=p.yData[0],C.push([n,a,i,s]),L.push(n),M.push([a,i,s]))}return{values:C,xData:L,yData:M}}}}return r.defaultOptions=n(a.defaultOptions,{params:{period:20,factor:.001,index:3},lineWidth:1,topLine:{styles:{lineWidth:1}},bottomLine:{styles:{lineWidth:1}},dataGrouping:{approximation:"averages"}}),s(r.prototype,{areaLinesNames:["top","bottom"],linesApiNames:["topLine","bottomLine"],nameBase:"Acceleration Bands",nameComponents:["period","factor"],pointArrayMap:["top","middle","bottom"],pointValKey:"middle"}),t.compose(r),e.registerSeriesType("abands",r),r}),i(e,"masters/indicators/acceleration-bands.src.js",[],function(){})});//# sourceMappingURL=acceleration-bands.js.map