/**
 * Highstock JS v11.2.0 (2023-10-30)
 *
 * Indicator series type for Highcharts Stock
 *
 * (c) 2010-2021 Paweł Fus
 *
 * License: www.highcharts.com/license
 */!function(t){"object"==typeof module&&module.exports?(t.default=t,module.exports=t):"function"==typeof define&&define.amd?define("highcharts/indicators/bollinger-bands",["highcharts","highcharts/modules/stock"],function(e){return t(e),t.Highcharts=e,t}):t("undefined"!=typeof Highcharts?Highcharts:void 0)}(function(t){"use strict";var e=t?t._modules:{};function i(t,e,i,o){t.hasOwnProperty(e)||(t[e]=o.apply(null,i),"function"==typeof CustomEvent&&window.dispatchEvent(new CustomEvent("HighchartsModuleLoaded",{detail:{path:e,module:t[e]}})))}i(e,"Stock/Indicators/MultipleLinesComposition.js",[e["Core/Series/SeriesRegistry.js"],e["Core/Utilities.js"]],function(t,e){var i;let{sma:{prototype:o}}=t.seriesTypes,{defined:s,error:n,merge:a}=e;return function(t){let i=[],r=["bottomLine"],l=["top","bottom"],p=["top"];function h(t){return"plot"+t.charAt(0).toUpperCase()+t.slice(1)}function d(t,e){let i=[];return(t.pointArrayMap||[]).forEach(t=>{t!==e&&i.push(h(t))}),i}function c(){let t=this,e=t.pointValKey,i=t.linesApiNames,r=t.areaLinesNames,l=t.points,p=t.options,c=t.graph,u={options:{gapSize:p.gapSize}},f=[],m=d(t,e),y=l.length,g;if(m.forEach((t,e)=>{for(f[e]=[];y--;)g=l[y],f[e].push({x:g.x,plotX:g.plotX,plotY:g[t],isNull:!s(g[t])});y=l.length}),t.userOptions.fillColor&&r.length){let e=m.indexOf(h(r[0])),i=f[e],s=1===r.length?l:f[m.indexOf(h(r[1]))],n=t.color;t.points=s,t.nextPoints=i,t.color=t.userOptions.fillColor,t.options=a(l,u),t.graph=t.area,t.fillGraph=!0,o.drawGraph.call(t),t.area=t.graph,delete t.nextPoints,delete t.fillGraph,t.color=n}i.forEach((e,i)=>{f[i]?(t.points=f[i],p[e]?t.options=a(p[e].styles,u):n('Error: "There is no '+e+' in DOCS options declared. Check if linesApiNames are consistent with your DOCS line names."'),t.graph=t["graph"+e],o.drawGraph.call(t),t["graph"+e]=t.graph):n('Error: "'+e+" doesn't have equivalent in pointArrayMap. To many elements in linesApiNames relative to pointArrayMap.\"")}),t.points=l,t.options=p,t.graph=c,o.drawGraph.call(t)}function u(t){let e,i=[],s=[];if(t=t||this.points,this.fillGraph&&this.nextPoints){if((e=o.getGraphPath.call(this,this.nextPoints))&&e.length){e[0][0]="L",i=o.getGraphPath.call(this,t),s=e.slice(0,i.length);for(let t=s.length-1;t>=0;t--)i.push(s[t])}}else i=o.getGraphPath.apply(this,arguments);return i}function f(t){let e=[];return(this.pointArrayMap||[]).forEach(i=>{e.push(t[i])}),e}function m(){let t=this.pointArrayMap,e=[],i;e=d(this),o.translate.apply(this,arguments),this.points.forEach(o=>{t.forEach((t,s)=>{i=o[t],this.dataModify&&(i=this.dataModify.modifyValue(i)),null!==i&&(o[e[s]]=this.yAxis.toPixels(i,!0))})})}t.compose=function(t){if(e.pushUnique(i,t)){let e=t.prototype;e.linesApiNames=e.linesApiNames||r.slice(),e.pointArrayMap=e.pointArrayMap||l.slice(),e.pointValKey=e.pointValKey||"top",e.areaLinesNames=e.areaLinesNames||p.slice(),e.drawGraph=c,e.getGraphPath=u,e.toYData=f,e.translate=m}return t}}(i||(i={})),i}),i(e,"Stock/Indicators/BB/BBIndicator.js",[e["Stock/Indicators/MultipleLinesComposition.js"],e["Core/Series/SeriesRegistry.js"],e["Core/Utilities.js"]],function(t,e,i){let{sma:o}=e.seriesTypes,{extend:s,isArray:n,merge:a}=i;class r extends o{constructor(){super(...arguments),this.data=void 0,this.options=void 0,this.points=void 0}init(){e.seriesTypes.sma.prototype.init.apply(this,arguments),this.options=a({topLine:{styles:{lineColor:this.color}},bottomLine:{styles:{lineColor:this.color}}},this.options)}getValues(t,i){let o,s,a,r,l,p,h,d,c;let u=i.period,f=i.standardDeviation,m=[],y=[],g=t.xData,b=t.yData,x=b?b.length:0,v=[];if(g.length<u)return;let C=n(b[0]);for(c=u;c<=x;c++)l=g.slice(c-u,c),p=b.slice(c-u,c),r=(d=e.seriesTypes.sma.prototype.getValues.call(this,{xData:l,yData:p},i)).xData[0],o=d.yData[0],h=function(t,e,i,o){let s=t.length,n=0,a,r=0;for(;n<s;n++)r+=(a=(i?t[n][e]:t[n])-o)*a;return Math.sqrt(r/=s-1)}(p,i.index,C,o),s=o+f*h,a=o-f*h,v.push([r,s,o,a]),m.push(r),y.push([s,o,a]);return{values:v,xData:m,yData:y}}}return r.defaultOptions=a(o.defaultOptions,{params:{period:20,standardDeviation:2,index:3},bottomLine:{styles:{lineWidth:1,lineColor:void 0}},topLine:{styles:{lineWidth:1,lineColor:void 0}},tooltip:{pointFormat:'<span style="color:{point.color}">●</span><b> {series.name}</b><br/>Top: {point.top}<br/>Middle: {point.middle}<br/>Bottom: {point.bottom}<br/>'},marker:{enabled:!1},dataGrouping:{approximation:"averages"}}),s(r.prototype,{areaLinesNames:["top","bottom"],linesApiNames:["topLine","bottomLine"],nameComponents:["period","standardDeviation"],pointArrayMap:["top","middle","bottom"],pointValKey:"middle"}),t.compose(r),e.registerSeriesType("bb",r),r}),i(e,"masters/indicators/bollinger-bands.src.js",[],function(){})});//# sourceMappingURL=bollinger-bands.js.map