/**
 * Highstock JS v11.2.0 (2023-10-30)
 *
 * Indicator series type for Highcharts Stock
 *
 * (c) 2010-2021 Kamil Kulig
 *
 * License: www.highcharts.com/license
 */!function(e){"object"==typeof module&&module.exports?(e.default=e,module.exports=e):"function"==typeof define&&define.amd?define("highcharts/indicators/regressions",["highcharts","highcharts/modules/stock"],function(t){return e(t),e.Highcharts=t,e}):e("undefined"!=typeof Highcharts?Highcharts:void 0)}(function(e){"use strict";var t=e?e._modules:{};function s(e,t,s,i){e.hasOwnProperty(t)||(e[t]=i.apply(null,s),"function"==typeof CustomEvent&&window.dispatchEvent(new CustomEvent("HighchartsModuleLoaded",{detail:{path:t,module:e[t]}})))}s(t,"Stock/Indicators/LinearRegression/LinearRegressionIndicator.js",[t["Core/Series/SeriesRegistry.js"],t["Core/Utilities.js"]],function(e,t){let{sma:s}=e.seriesTypes,{isArray:i,extend:n,merge:r}=t;class o extends s{constructor(){super(...arguments),this.data=void 0,this.options=void 0,this.points=void 0}getRegressionLineParameters(e,t){let s=this.options.params.index,n=function(e,t){return i(e)?e[t]:e},r=e.reduce(function(e,t){return t+e},0),o=t.reduce(function(e,t){return n(t,s)+e},0),a=r/e.length,l=o/t.length,p,d,c=0,u=0;for(d=0;d<e.length;d++)c+=(p=e[d]-a)*(n(t[d],s)-l),u+=Math.pow(p,2);let g=u?c/u:0;return{slope:g,intercept:l-g*a}}getEndPointY(e,t){return e.slope*t+e.intercept}transformXData(e,t){let s=e[0];return e.map(function(e){return(e-s)/t})}findClosestDistance(e){let t,s,i;for(i=1;i<e.length-1;i++)(t=e[i]-e[i-1])>0&&(void 0===s||t<s)&&(s=t);return s}getValues(e,t){let s,i,n,r,o,a,l,p,d;let c=e.xData,u=e.yData,g=t.period,h={xData:[],yData:[],values:[]},f=this.options.params.xAxisUnit||this.findClosestDistance(c);for(i=g-1;i<=c.length-1;i++)n=i-g+1,r=i+1,o=c[i],l=c.slice(n,r),p=u.slice(n,r),d=this.transformXData(l,f),s=this.getRegressionLineParameters(d,p),a=this.getEndPointY(s,d[d.length-1]),h.values.push({regressionLineParameters:s,x:o,y:a}),h.xData.push(o),h.yData.push(a);return h}}return o.defaultOptions=r(s.defaultOptions,{params:{xAxisUnit:null},tooltip:{valueDecimals:4}}),n(o.prototype,{nameBase:"Linear Regression Indicator"}),e.registerSeriesType("linearRegression",o),o}),s(t,"Stock/Indicators/LinearRegressionSlopes/LinearRegressionSlopesIndicator.js",[t["Core/Series/SeriesRegistry.js"],t["Core/Utilities.js"]],function(e,t){let{linearRegression:s}=e.seriesTypes,{extend:i,merge:n}=t;class r extends s{constructor(){super(...arguments),this.data=void 0,this.options=void 0,this.points=void 0}getEndPointY(e){return e.slope}}return r.defaultOptions=n(s.defaultOptions),i(r.prototype,{nameBase:"Linear Regression Slope Indicator"}),e.registerSeriesType("linearRegressionSlope",r),r}),s(t,"Stock/Indicators/LinearRegressionIntercept/LinearRegressionInterceptIndicator.js",[t["Core/Series/SeriesRegistry.js"],t["Core/Utilities.js"]],function(e,t){let{linearRegression:s}=e.seriesTypes,{extend:i,merge:n}=t;class r extends s{constructor(){super(...arguments),this.data=void 0,this.options=void 0,this.points=void 0}getEndPointY(e){return e.intercept}}return r.defaultOptions=n(s.defaultOptions),i(r.prototype,{nameBase:"Linear Regression Intercept Indicator"}),e.registerSeriesType("linearRegressionIntercept",r),r}),s(t,"Stock/Indicators/LinearRegressionAngle/LinearRegressionAngleIndicator.js",[t["Core/Series/SeriesRegistry.js"],t["Core/Utilities.js"]],function(e,t){let{linearRegression:s}=e.seriesTypes,{extend:i,merge:n}=t;class r extends s{constructor(){super(...arguments),this.data=void 0,this.options=void 0,this.points=void 0}slopeToAngle(e){return Math.atan(e)*(180/Math.PI)}getEndPointY(e){return this.slopeToAngle(e.slope)}}return r.defaultOptions=n(s.defaultOptions,{tooltip:{pointFormat:'<span style="color:{point.color}">●</span>{series.name}: <b>{point.y}\xb0</b><br/>'}}),i(r.prototype,{nameBase:"Linear Regression Angle Indicator"}),e.registerSeriesType("linearRegressionAngle",r),r}),s(t,"masters/indicators/regressions.src.js",[],function(){})});//# sourceMappingURL=regressions.js.map